Index: trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp
===================================================================
--- trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 585)
+++ trunk/modules/vci_io_bridge/caba/source/src/vci_io_bridge.cpp	(revision 712)
@@ -1514,37 +1756,68 @@
     //////////////////////////////////////////////////////////////////////////////
 
-    switch( r_config_rsp_fsm.read() ) 
-    {
-    /////////////////////
-    case CONFIG_RSP_IDLE:  // waiting a VCI response from IOX network
-                           // flit on IOX network is not consumed
-    {    	
-        if ( p_vci_ini_iox.rspval.read() ) 
-		{
-            if ( (p_vci_ini_iox.rpktid.read() & 0x5) == 0x1 )   // multi-flits response
+    // does nothing if FIFO full
+    if ( m_config_rsp_rerror_fifo.wok() )
+    {
+        switch( r_config_rsp_fsm.read() ) 
+        {
+            /////////////////////////
+            case CONFIG_RSP_IDLE_IOX:  // IOX requests have highest priority
+                                       // no flit on IOX network is consumed
+            {    	
+                if ( p_vci_ini_iox.rspval.read() )  // IOX request
+	            {
+                    if ( (p_vci_ini_iox.rpktid.read() & 0x5) == 0x1 )   // multi-flits 
+                    {
+                        r_config_rsp_fsm   = CONFIG_RSP_PUT_LOW;
+                    }
+                    else                                                // single flit    
+                    {
+                        r_config_rsp_fsm   = CONFIG_RSP_PUT_UNC;
+                    }
+    		    }
+                else if ( r_config_cmd_to_config_rsp_req.read() ) // LOC request
+                {
+                    r_config_rsp_fsm = CONFIG_RSP_PUT_LOC;
+                }
+    		    break;
+            }
+            /////////////////////////
+            case CONFIG_RSP_IDLE_LOC:  // LOC requests have highest priority
+                                       // no flit on IOX network is consumed
+            {    	
+                if ( r_config_cmd_to_config_rsp_req.read() ) // LOC request
+                {
+                    r_config_rsp_fsm = CONFIG_RSP_PUT_LOC;
+                }
+                else if ( p_vci_ini_iox.rspval.read() ) // IOX request
+	            {
+                    if ( (p_vci_ini_iox.rpktid.read() & 0x5) == 0x1 )   // multi-flits 
+                    {
+                        r_config_rsp_fsm   = CONFIG_RSP_PUT_LOW;
+                    }
+                    else                                                // single flit    
+                    {
+                        r_config_rsp_fsm   = CONFIG_RSP_PUT_UNC;
+                    }
+    		    }
+               	break;
+            }
+            ////////////////////////
+            case CONFIG_RSP_PUT_LOW:   // put 32 low bits into CONFIG_RSP fifo
+                                       // no flit on IOX network is consumed
             {
-                r_config_rsp_fsm   = CONFIG_RSP_PUT_LO;
-            }
-            else                                                // single flit response
-            {
-                r_config_rsp_fsm   = CONFIG_RSP_PUT_UNC;
-            	
-                assert(  p_vci_ini_iox.reop.read() and 
-                "ERROR in vci_io_bridge : a remote config response should be one flit");
-            }
-		}
-		break;
-    }
-    ///////////////////////
-    case CONFIG_RSP_PUT_LO:   // try to write 32 low bits into CONFIG_RSP fifo
-                              // flit on IOX network is not consumed
-    {
-        if ( not r_alloc_fifo_config_rsp_local.read() and  m_config_rsp_data_fifo.wok() )	
-        {
-            r_config_rsp_fsm   = CONFIG_RSP_PUT_HI;
+                config_rsp_fifo_put    = true;
+                config_rsp_fifo_rerror = p_vci_ini_iox.rerror.read();
+                config_rsp_fifo_rdata  = (uint32_t)p_vci_ini_iox.rdata.read();
+                config_rsp_fifo_rsrcid = p_vci_ini_iox.rsrcid.read();
+                config_rsp_fifo_rtrdid = p_vci_ini_iox.rtrdid.read();
+                config_rsp_fifo_rpktid = p_vci_ini_iox.rpktid.read();
+                config_rsp_fifo_reop   = false;
+
+                r_config_rsp_fsm   = CONFIG_RSP_PUT_HI;
 
 #if DEBUG_CONFIG_RSP
 if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_RSP_PUT_LO> Push multi-flit response into CONFIG_RSP fifo:" 
+std::cout << "  <IOB CONFIG_RSP_PUT_LOW> Push multi-flit response into CONFIG_RSP FIFO" 
           << " / rsrcid = " << std::hex << p_vci_ini_iox.rsrcid.read()
           << " / rtrdid = " << p_vci_ini_iox.rtrdid.read()
@@ -1554,40 +1827,54 @@
           << " / rerror = " << p_vci_ini_iox.rerror.read() << std::endl;
 #endif
-    	}
-    	break;
-    }
-    ///////////////////////
-    case CONFIG_RSP_PUT_HI:    // try to write 32 high bits into CONFIG_RSP fifo
-                               // flit on IOX network is consumed if success
-    {
-        if ( not r_alloc_fifo_config_rsp_local.read() and  m_config_rsp_data_fifo.wok() )	
-        {
-            if( p_vci_ini_iox.reop.read() )    r_config_rsp_fsm = CONFIG_RSP_IDLE;
-            else                               r_config_rsp_fsm = CONFIG_RSP_PUT_LO;
+    	        break;
+            }
+            ///////////////////////
+            case CONFIG_RSP_PUT_HI:    // put 32 high bits into CONFIG_RSP fifo
+                                   // flit on IOX network is consumed 
+            {
+                config_rsp_fifo_put    = true;
+                config_rsp_fifo_rerror = p_vci_ini_iox.rerror.read();
+                config_rsp_fifo_rdata  = (uint32_t)(p_vci_ini_iox.rdata.read() >> 32);
+                config_rsp_fifo_rsrcid = p_vci_ini_iox.rsrcid.read();
+                config_rsp_fifo_rtrdid = p_vci_ini_iox.rtrdid.read();
+                config_rsp_fifo_rpktid = p_vci_ini_iox.rpktid.read();
+                config_rsp_fifo_reop   = p_vci_ini_iox.reop.read();
+
+                if( p_vci_ini_iox.reop.read() ) r_config_rsp_fsm = CONFIG_RSP_IDLE_LOC;
+                else                            r_config_rsp_fsm = CONFIG_RSP_PUT_LOW;
 
 #if DEBUG_CONFIG_RSP
 if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_RSP_PUT_HI> Push multi-flit response into CONFIG_RSP fifo:" 
+std::cout << "  <IOB CONFIG_RSP_PUT_HI> Push multi-flit response into CONFIG_RSP FIFO" 
           << " / rsrcid = " << std::hex << p_vci_ini_iox.rsrcid.read()
           << " / rtrdid = " << p_vci_ini_iox.rtrdid.read()
           << " / rpktid = " << p_vci_ini_iox.rpktid.read()
-          << " / rdata = " << (uint32_t)(p_vci_ini_iox.rdata.read()>>32)
+          << " / rdata = " << (uint32_t)(p_vci_ini_iox.rdata.read() >> 32)
           << " / reop  = " << p_vci_ini_iox.reop.read()
           << " / rerror = " << p_vci_ini_iox.rerror.read() << std::endl;
 #endif
-    	}
-    	break;
-    }
-    ////////////////////////
-    case CONFIG_RSP_PUT_UNC:   // try to write single flit into CONFIG_RSP fifo
-                               // flit on IOX network is consumed if success
-    {
-        if ( not r_alloc_fifo_config_rsp_local.read() and  m_config_rsp_data_fifo.wok() )	
-    	{
-            r_config_rsp_fsm   = CONFIG_RSP_IDLE;
+    	        break;
+            }
+            ////////////////////////
+            case CONFIG_RSP_PUT_UNC:   // put single flit into CONFIG_RSP fifo
+                                       // flit on IOX network is consumed 
+            {
+                assert(  p_vci_ini_iox.reop.read() and 
+                "ERROR in vci_io_bridge : a remote config response should be one flit");
+
+                config_rsp_fifo_put    = true;
+                config_rsp_fifo_rerror = p_vci_ini_iox.rerror.read();
+                config_rsp_fifo_rdata  = (uint32_t)p_vci_ini_iox.rdata.read();
+                config_rsp_fifo_rsrcid = p_vci_ini_iox.rsrcid.read();
+                config_rsp_fifo_rtrdid = p_vci_ini_iox.rtrdid.read();
+                config_rsp_fifo_rpktid = p_vci_ini_iox.rpktid.read();
+                config_rsp_fifo_reop   = true;
+
+                // update priority
+                r_config_rsp_fsm   = CONFIG_RSP_IDLE_LOC;
 
 #if DEBUG_CONFIG_RSP
 if( m_debug_activated ) 
-std::cout << "  <IOB CONFIG_RSP_PUT_UNC> Push single flit response into CONFIG_RSP fifo:" 
+std::cout << "  <IOB CONFIG_RSP_PUT_UNC> Push single flit response into CONFIG_RSP FIFO" 
           << " / rsrcid = " << std::hex << p_vci_ini_iox.rsrcid.read()
           << " / rtrdid = " << p_vci_ini_iox.rtrdid.read()
@@ -1597,146 +1884,188 @@
           << " / rerror = " << p_vci_ini_iox.rerror.read() << std::endl;
 #endif
-    	}
-    	break;
-    }
-    } // end switch CONFIG_RSP FSM
-
-    /////////////////////////////////////////////////////////////////////////////////
-    // If the IOB component has IRQ ports, the IRQ FSM detects all changes 
-    // on the 32 p_irq[i] ports and request a VCI write transaction to the 
-    // MISS_INIT FSM, using the 64 r_irq_request[i] and r_irq_pending[i] flip-flops.
-    /////////////////////////////////////////////////////////////////////////////////
-
-    if ( m_has_irqs )
-    {
-        for ( size_t i = 0; i<32; ++i )
-        {
-            r_irq_request[i] = ( p_irq[i]->read() == not r_irq_pending[i].read() );
-            r_irq_pending[i] = p_irq[i]->read();
-        }
-    }
-        
+    	        break;
+            }
+            ////////////////////////
+            case CONFIG_RSP_PUT_LOC:   // put single flit into CONFIG_RSP fifo
+                                       // no flit on IOX network is consumed 
+            {
+                config_rsp_fifo_put    = true;
+                config_rsp_fifo_rerror = r_config_cmd_to_config_rsp_rerror.read();
+                config_rsp_fifo_rdata  = r_config_cmd_to_config_rsp_rdata.read();
+                config_rsp_fifo_rsrcid = r_config_cmd_srcid.read();
+                config_rsp_fifo_rtrdid = r_config_cmd_trdid.read();
+                config_rsp_fifo_rpktid = r_config_cmd_pktid.read();
+                config_rsp_fifo_reop   = true;
+
+                // acknowledge request 
+                r_config_cmd_to_config_rsp_req = false;
+
+                // update priority
+                r_config_rsp_fsm   = CONFIG_RSP_IDLE_IOX;
+
+#if DEBUG_CONFIG_RSP
+if( m_debug_activated ) 
+std::cout << "  <IOB CONFIG_RSP_PUT_UNC> Push single flit response into CONFIG_RSP FIFO" 
+          << " / rsrcid = " << std::hex << r_config_cmd_srcid.read()
+          << " / rtrdid = " << r_config_cmd_trdid.read()
+          << " / rpktid = " << r_config_cmd_pktid.read()
+          << " / rdata = "  << r_config_cmd_to_config_rsp_rdata.read()
+          << " / reop  = "  << true
+          << " / rerror = " << r_config_cmd_to_config_rsp_rerror.read() << std::endl;
+#endif
+    	        break;
+            }
+        } // end switch CONFIG_RSP FSM
+    } // end if FIFO full
+
     ///////////////////////////////////////////////////////////////////////////////////
-    // The MISS_WTI_CMD FSM send VCI commands on the Internal Network.
-    // It handles PTE MISS requests from TLB_MISS FSM and software IRQs.
-    // It supports several simultaneous VCI transactions.
+    // The MISS_WTI_CMD component is a combinational switch that push one single flit
+    // VCI command in the MISS_WTI FIFO to INT Network, depending on two clients :
+    // 1. MISS requests from TLB_MISS FSM :
+    //    These requests have highest priority because a TLB MISS is a blocking event
+    //    for the DMA FSM. The r_tlb_to_miss_wti_cmd_req flip-flop is reset by the
+    //    MISS_WTI_RSP FSM only when the response is received.
+    // 2. WTI requests from DMA_CMD FSM :
+    //    These requestsare non blocking events, and the r_dma_cmd_to_miss_wti_cmd_req 
+    //    flip-flop is reset as soon as the WTI command has been sent. 
+    //    There is two types of WTI requests:
+    //    - external WTI from peripherals on IOX network.
+    //    - internal WTI caused by illegal DMA requests.
     ////////////////////////////////////////////////////////////////////////////////////
  
-    switch ( r_miss_wti_cmd_fsm.read() ) 
+    if ( r_tlb_to_miss_wti_cmd_req.read() and  
+         m_miss_wti_cmd_addr_fifo.wok() )                   // put MISS READ
+    {
+        miss_wti_cmd_fifo_put     = true;
+        miss_wti_cmd_fifo_address = r_tlb_paddr.read();      
+        miss_wti_cmd_fifo_wdata   = 0;                 
+        miss_wti_cmd_fifo_cmd     = vci_param_int::CMD_READ;
+        miss_wti_cmd_fifo_pktid   = PKTID_MISS;
+        miss_wti_cmd_fifo_srcid   = m_int_srcid;
+        miss_wti_cmd_fifo_trdid   = 0;
+
+#if DEBUG_MISS_WTI_CMD
+if( m_debug_activated )
+std::cout << "  <IOB MISS_WTI_CMD_WTI> push MISS TLB command into MISS_WTI FIFO"
+          << " / PADDR = " << miss_wti_cmd_fifo_address << std::endl;
+#endif
+
+    }
+    else if ( r_dma_cmd_to_miss_wti_cmd_req.read() and  
+              m_miss_wti_cmd_addr_fifo.wok() )               // put WTI READ / WRITE
+    {
+        r_dma_cmd_to_miss_wti_cmd_req = false;
+
+        miss_wti_cmd_fifo_put     = true;
+        miss_wti_cmd_fifo_cmd     = r_dma_cmd_to_miss_wti_cmd_cmd.read();
+        miss_wti_cmd_fifo_address = r_dma_cmd_to_miss_wti_cmd_addr.read();
+        miss_wti_cmd_fifo_wdata   = r_dma_cmd_to_miss_wti_cmd_wdata.read();
+        miss_wti_cmd_fifo_srcid   = r_dma_cmd_to_miss_wti_cmd_srcid.read();
+        miss_wti_cmd_fifo_trdid   = r_dma_cmd_to_miss_wti_cmd_trdid.read();
+        miss_wti_cmd_fifo_pktid   = r_dma_cmd_to_miss_wti_cmd_pktid.read();
+
+#if DEBUG_MISS_WTI_CMD
+if( m_debug_activated )
+std::cout << "  <IOB MISS_WTI_CMD_WTI> push WTI command into MISS_WTI FIFO"
+          << " / CMD = " << miss_wti_cmd_fifo_cmd
+          << " / PADDR = " << miss_wti_cmd_fifo_address << std::endl;
+#endif
+
+    }     
+
+    ///////////////////////////////////////////////////////////////////////////////////
+    // The MISS_WTI_RSP FSM handles VCI responses from the INT network:
+    // - for a TLB MISS (multi-flits read transaction), the cache line
+    //   is written in r_tlb_buf_data[], and r_tlb_to_miss_wti_cmd_req flip-flop is reset.  
+    // - for a WTI_IOX (single flit write transaction), the response must be
+    //   forwarded to the source peripheral on the INT network
+    // - for a WTI_MMU (single flit write transaction), there is nothing to do.
+    //
+    // TODO VCI addressing errors for TLB MISS or for WTI_MMU (i.e. kernel errors...) 
+    // are registered in the r_miss_wti_rsp_error_miss & r_miss_wti_rsp_error_wti
+    // flip-flops, and simulation stops... They could be signaled to OS by a WTI.
+    ////////////////////////////////////////////////////////////////////////////////////
+ 
+    switch ( r_miss_wti_rsp_fsm.read() ) 
     {
         ///////////////////////
-        case MISS_WTI_CMD_IDLE:   // TLB MISS have highest priority
+        case MISS_WTI_RSP_IDLE:   // waiting a VCI response
+                                  // no VCI flit is consumed
         {
-            if ( r_tlb_miss_req.read() )
+            if ( p_vci_ini_int.rspval.read() ) 
             {
-                r_miss_wti_cmd_fsm = MISS_WTI_CMD_MISS;
-            }
-            else if ( r_iommu_wti_enable.read() )
+                if ( p_vci_ini_int.rpktid.read() == PKTID_WTI_IOX ) 
+                {
+                    r_miss_wti_rsp_fsm   = MISS_WTI_RSP_WTI_IOX;
+                }
+                else if ( p_vci_ini_int.rpktid.read() == PKTID_WTI_MMU ) 
+                {
+                    r_miss_wti_rsp_fsm   = MISS_WTI_RSP_WTI_MMU;
+                }
+                else if ( p_vci_ini_int.rpktid.read() == PKTID_MISS )
+                {
+                    r_miss_wti_rsp_fsm   = MISS_WTI_RSP_MISS;
+                    r_miss_wti_rsp_count = 0;
+                }
+                else
+                {
+                    assert ( false and
+                    "VCI_IO_BRIDGE ERROR : illegal response type on INT network");
+                }
+            }
+            break;
+        }
+        //////////////////////////
+        case MISS_WTI_RSP_WTI_IOX:   // Handling response to a peripheral WTI
+                                     // consume VCI flit and transfer response
+                                     // to DMA_RSP FSM in dedicated registers
+                                     // if no pending previous request.
+        {
+            assert( p_vci_ini_int.reop.read() and 
+            "VCI_IO_BRIDGE ERROR: WTI_IOX response should have one single flit" ); 
+                    
+            if ( not r_miss_wti_rsp_to_dma_rsp_req.read() ) // no previous pending request
             {
-                // checking if there is a new pending interrupt
-                bool found = false;
-                size_t n;
-                for ( n = 0 ; (n < 32) and not found ; n++ )
-                {
-                    if ( r_irq_request[n] ) found = true;
-                }
-                if ( found )
-                {
-                    r_miss_wti_cmd_index = n;
-                    r_miss_wti_cmd_fsm   = MISS_WTI_CMD_WTI;
-                }
-            }
-			break;
+                r_miss_wti_rsp_to_dma_rsp_req    = true;
+                r_miss_wti_rsp_to_dma_rsp_rerror = p_vci_ini_int.rerror.read();
+                r_miss_wti_rsp_to_dma_rsp_rsrcid = p_vci_ini_int.rsrcid.read();
+                r_miss_wti_rsp_to_dma_rsp_rtrdid = p_vci_ini_int.rtrdid.read();
+                r_miss_wti_rsp_to_dma_rsp_rpktid = p_vci_ini_int.rpktid.read();
+
+                r_miss_wti_rsp_fsm = MISS_WTI_RSP_IDLE;
+
+#if DEBUG_MISS_WTI_RSP
+if( m_debug_activated )
+std::cout << "  <IOB MISS_WTI_RSP_WTI_IOX> Transfer response to a WTI_IOX" << std::endl;
+#endif
+            }
+            break;
         }
-        //////////////////////     
-        case MISS_WTI_CMD_WTI:   // send a single flit IRQ WRITE on INT Network
-                                 // address is defined by IRQ_VECTOR[r_miss_wti_index]
-                                 // data is defined by r_irq_pending[r_miss_wti_index]
+        //////////////////////////  
+        case MISS_WTI_RSP_WTI_MMU:   // Handling response to an iommu WTI
+                                     // consume VCI flit and test VCI error.
         {
-            if ( p_vci_ini_int.cmdack ) 
+            assert( p_vci_ini_int.reop.read() and 
+            "VCI_IO_BRIDGE ERROR: WTI_MMU response should have one single flit" ); 
+                 
+            if ( (p_vci_ini_int.rerror.read()&0x1) != 0 )  // error reported
             {
-                // reset the request
-                r_irq_request[r_miss_wti_cmd_index.read()] = false;
-                r_miss_wti_cmd_fsm = MISS_WTI_RSP_WTI;		
-
-#if DEBUG_MISS_WTI
-if( m_debug_activated )
-std::cout << "  <IOB MISS_WTI_CMD_WTI> Send WTI write command on Internal Network"
-          << " / IRQID = " << std::dec << r_miss_wti_cmd_index.read() << std::endl;
-#endif
-            }
+                // set the specific error flip-flop
+                r_miss_wti_rsp_error_wti = true;
+                assert( false and 
+                "VCI_IO_BRIDGE ERROR: VCI error response for a WTI_MMU transaction");
+            }
+
+#if DEBUG_MISS_WTI_RSP
+if( m_debug_activated ) 
+std::cout << " <IOB MISS_WTI_RSP_WTI_MMU> Receive response to a WTI_MMU" << std::endl; 
+#endif
             break;
         }
         ///////////////////////
-        case MISS_WTI_CMD_MISS:   // send a TLB MISS request on INT Network
-        {
-            if ( p_vci_ini_int.cmdack ) 
-            {
-                r_tlb_buf_tag     = ( (r_tlb_paddr.read()) & CACHE_LINE_MASK ); 
-                r_tlb_buf_valid   = true;
-            
-                if( r_tlb_miss_type.read() == PTE1_MISS )
-                    r_tlb_buf_vaddr = (r_dma_cmd_vaddr.read() & 
-                                        ~M_PAGE_OFFSET_MASK & ~PTE1_LINE_OFFSET);
-                else
-                    r_tlb_buf_vaddr = (r_dma_cmd_vaddr.read() & 
-                                        ~K_PAGE_OFFSET_MASK & ~PTE2_LINE_OFFSET);
-                
-                r_miss_wti_cmd_fsm = MISS_WTI_RSP_MISS;		
-
-#if DEBUG_MISS_WTI
-if( m_debug_activated )
-std::cout << "  <IOB MISS_WTI_CMD_MISS> Send TLB MISS command on Internal Network" << std::hex
-          << " / address = " <<(vci_addr_t)((r_tlb_paddr.read())& CACHE_LINE_MASK) << std::endl;
-#endif
-            }
-            break;
-        }
-    } // end switch r_miss_wti_cmd_fsm
-
-    ///////////////////////////////////////////////////////////////////////////////////
-    // The MISS_WTI_RSP FSM handles VCI responses on the Internal Network.
-    // it can be response to TLB MISS (read transaction) or WTI (write transaction).
-    // It supports several simultaneous VCI transactions.
-    ////////////////////////////////////////////////////////////////////////////////////
- 
-    switch ( r_miss_wti_rsp_fsm.read() ) 
-    {
-        case MISS_WTI_RSP_IDLE:   // waiting a VCI response
-        {
-            if ( p_vci_ini_int.rspval.read() ) 
-            {
-                if ( p_vci_ini_int.rpktid.read() == PKTID_READ )  // it's a TLB MISS response
-                {
-                    r_miss_wti_rsp_fsm   = MISS_WTI_RSP_MISS;
-                    r_miss_wti_rsp_count = 0;
-                }
-                else                                       // it's a WTI WRITE response
-                {
-                    r_miss_wti_rsp_fsm   = MISS_WTI_RSP_WTI;
-
-                }
-            }
-            break;
-        }
-        //////////////////////
-        case MISS_WTI_RSP_WTI:   // Handling response to a WTI transaction
-        {
-            assert( p_vci_ini_int.reop.read() and 
-            "VCI_IO_BRIDGE ERROR: IRQ Write response should have one single flit" ); 
-
-            assert( ( (p_vci_ini_int.rerror.read()&0x1) == 0 ) and 
-            "VCI_IO_BRIDGE ERROR: IRQ Write response error !!!" ); 
-             // TODO handling error when using the IOMMU IRQ
-
-#if DEBUG_MISS_WTI
-if( m_debug_activated )
-std::cout << "  <IOB MISS_WTI_RSP_WTI> Response to WTI write" << std::endl;
-#endif
-            r_miss_wti_rsp_fsm = MISS_WTI_RSP_IDLE;
-            break;
-        }
-        ///////////////////////
-        case MISS_WTI_RSP_MISS:   // Handling response to a TLB MISS transaction
+        case MISS_WTI_RSP_MISS:   // Handling response to a TLB MISS 
+                                  // write cache line in r_tlb_buf buffer
+                                  // and analyse possible VCI error
+                                  // VCI flit is consumed.
         {
             if ( p_vci_ini_int.rspval.read() ) 
@@ -1744,36 +2073,35 @@
                 if ( (p_vci_ini_int.rerror.read()&0x1) != 0 )  // error reported
                 {
-                    r_miss_wti_rsp_error = true;
-                    if ( p_vci_ini_int.reop.read() ) 
-                    {    
-                        r_miss_wti_cmd_fsm = MISS_WTI_RSP_IDLE;
-                        r_tlb_miss_req = false; 
-                    }
-#if DEBUG_MISS_WTI
+                    // set the specific error flip-flop
+                    r_miss_wti_rsp_error_miss = true;
+                    assert( false and 
+                    "VCI_IO_BRIDGE ERROR: VCI error response for a TLB MISS transaction");
+
+                }
+                else                                           // no error
+                {
+
+#if DEBUG_MISS_WTI_CMD 
 if( m_debug_activated ) 
-std::cout << " <IOB MISS_WTI_RSP_MISS> ERROR " << std::endl; 
-#endif
-                }
-                else                                           // no error
-                { 
-                    bool   eop  	= p_vci_ini_int.reop.read();
-
-#if DEBUG_MISS_WTI 
-if( m_debug_activated ) 
-std::cout << "  <IOB MISS_WTI_RSP_MISS> Response to a tlb miss transaction"
+std::cout << "  <IOB MISS_WTI_RSP_MISS> Receive response to a TLB MISS"
           << " / Count = " << r_miss_wti_rsp_count.read()
           << " / Data = " << std::hex << p_vci_ini_int.rdata.read() << std::endl; 
 #endif
+                    r_tlb_buf_data[r_miss_wti_rsp_count.read()] = p_vci_ini_int.rdata.read();
+                }
+                    
+                if ( p_vci_ini_int.reop.read() )               // last flit
+                {    
+                    bool eop = p_vci_ini_int.eop.read();
                     assert(((eop == (r_miss_wti_rsp_count.read() == (m_words-1)))) and 
                     "VCI_IO_BRIDGE ERROR: invalid length for a TLB MISS response");
 
-                    r_tlb_buf_data[r_miss_wti_rsp_count.read()] = p_vci_ini_int.rdata.read();
+                    r_miss_wti_rsp_count      = 0;
+                    r_miss_wti_rsp_fsm        = MISS_WTI_RSP_IDLE;
+                    r_tlb_to_miss_wti_cmd_req = false; 
+                }
+                else                                           // not the last flit 
+                {
                     r_miss_wti_rsp_count = r_miss_wti_rsp_count.read() + 1;
-                    
-                    if ( eop ) 
-                    {
-                        r_tlb_miss_req = false;     //reset the request flip-flop
-                        r_miss_wti_cmd_fsm = MISS_WTI_RSP_IDLE;		
-                    }
                 }
             }
@@ -1782,59 +2110,8 @@
     } // end  switch r_miss_wti_rsp_fsm
 
-    /////////////////////////////////////////////////////////////////////////
-    // This flip-flop allocates the access to the CONFIG_RSP fifo
-    // with a round robin priority between 2 clients FSMs :
-    // - CONFIG_CMD : to put a response to a local config command.
-    // - CONFIG_RSP : to put a response to a peripheral config command.
-    // The ressource is always allocated.
-    // A new allocation occurs when the owner FSM is not using it,
-    // and the other FSM is requiring it.
-    /////////////////////////////////////////////////////////////////////////
-    
-    if ( r_alloc_fifo_config_rsp_local.read() )
-    {
-        if ( (r_config_rsp_fsm.read() != CONFIG_RSP_IDLE) and   // config_rsp_fsm requiring
-             (r_config_cmd_fsm.read() != CONFIG_CMD_RSP) )      // config_cmd_fsm not requiring 
-        r_alloc_fifo_config_rsp_local = false;
-    }
-    else 
-    {
-        if ( (r_config_cmd_fsm.read() == CONFIG_CMD_RSP) and    // config_cmd_fsm requiring
-             (r_config_rsp_fsm.read() == CONFIG_RSP_IDLE) )     // config_rsp_fsm not requiring
-        r_alloc_fifo_config_rsp_local = true;
-    }
-
-    /////////////////////////////////////////////////////////////////////////
-    // This flip-flop allocates the access to the DMA_RSP fifo
-    // with a round robin priority between 2 clients FSMs :
-    // - DMA_CMD : to put a error response in case of bad address translation
-    // - DMA_RSP : to put a normal response to a DMA transaction.
-    // The ressource is always allocated.
-    // A new allocation occurs when the owner FSM is not using it,
-    // and the other FSM is requiring it.
-    /////////////////////////////////////////////////////////////////////////
-    
-    if ( r_alloc_fifo_dma_rsp_local.read() )
-    {
-        if ( (r_dma_rsp_fsm.read() == DMA_RSP_FIFO_PUT) and
-             (r_dma_cmd_fsm.read() != DMA_CMD_FIFO_PUT_RSP) )
-        r_alloc_fifo_dma_rsp_local = false;
-    }
-    else 
-    {
-        if ( (r_dma_cmd_fsm.read() == DMA_CMD_FIFO_PUT_RSP) and
-             (r_dma_rsp_fsm.read() != DMA_RSP_FIFO_PUT) )
-        r_alloc_fifo_dma_rsp_local = true;
-    }
-
-    // Define GET signals for all output FIFOs
-    dma_cmd_fifo_get    = p_vci_ini_ram.cmdack.read();
-    dma_rsp_fifo_get    = p_vci_tgt_iox.rspack.read();
-    config_cmd_fifo_get = p_vci_ini_iox.cmdack.read();
-    config_rsp_fifo_get = p_vci_tgt_int.rspack.read();
 
     ///////////////////////////////////////////////////////////
     // DMA_CMD fifo update
-    // One writer : DMA_CMD FSM
+    // writer : DMA_CMD FSM
     ///////////////////////////////////////////////////////////
 
